lparameters tcClass, ;
	tcLibrary, ;
	tnObjCode
local lcClass, ;
	lcLibrary

* Open the report listener table (create it if necessary).

if not used('OutputConfig')
	if not file('OutputConfig.DBF')
		do (_ReportOutput) with -100
	endif not file('OutputConfig.DBF')
	use OutputConfig
endif not used('OutputConfig')

* If the specified listener is already there, ensure it's enabled by setting
* ObjCode to the proper value. Otherwise, add a record for it.

lcClass   = upper(tcClass)
lcLibrary = upper(tcLibrary)
locate for ObjType = 100 and upper(ObjName) == lcClass and ;
	upper(ObjValue) == lcLibrary
if found()
	replace ObjCode with tnObjCode
else
	insert into OutputConfig ;
			(ObjType, ;
			ObjCode, ;
			ObjName, ;
			ObjValue) ;
		values ;
			(100, ;
			tnObjCode, ;
			tcClass, ;
			tcLibrary)
endif found()

* Disable any other listeners with the same ObjCode by setting their ObjCode
* value to an unused value.

replace ObjCode with ObjCode + 100 for ObjType = 100 and ;
	ObjCode = tnObjCode and not upper(ObjName) == lcClass

* Clean up and exit.

use
